/* Produced by CVXGEN, 2011-05-04 05:52:04 -0700.  */
/* CVXGEN is Copyright (C) 2006-2011 Jacob Mattingley, jem@cvxgen.com. */
/* The code in this file is Copyright (C) 2006-2011 Jacob Mattingley. */
/* CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial */
/* applications without prior written permission from Jacob Mattingley. */

/* Filename: testsolver.c. */
/* Description: Basic test harness for solver.c. */

#include "solver.h"

Vars vars;
Params params;
Workspace work;
Settings settings;
#define NUMTESTS 0

int main(int argc, char **argv) {
  int num_iters;
#if (NUMTESTS > 0)
  int i;
  double time;
  double time_per;
#endif

  set_defaults();
  setup_indexing();
  load_default_data();

  /* Solve problem instance for the record. */
  settings.verbose = 1;
  num_iters = solve();

#ifndef ZERO_LIBRARY_MODE
#if (NUMTESTS > 0)
  /* Now solve multiple problem instances for timing purposes. */
  settings.verbose = 0;

  tic();
  for (i = 0; i < NUMTESTS; i++) {
    solve();
  }
  time = tocq();

  printf("Timed %d solves over %.3f seconds.\n", NUMTESTS, time);
  time_per = time / NUMTESTS;

  if (time_per > 1) {
    printf("Actual time taken per solve: %.3g s.\n", time_per);
  } else if (time_per > 1e-3) {
    printf("Actual time taken per solve: %.3g ms.\n", 1e3*time_per);
  } else {
    printf("Actual time taken per solve: %.3g us.\n", 1e6*time_per);
  }
#endif
#endif

  return 0;
}

void load_default_data(void) {
  params.B[0] = 0.203191610298302;
  params.B[1] = 0.832591290472419;
  params.B[2] = -0.836381044348223;
  params.B[3] = 0.0433104207906521;
  params.B[4] = 1.57178781739062;
  params.B[5] = 1.58517235573375;
  params.B[6] = -1.49765875814465;
  params.B[7] = -1.17102848744725;
  params.B[8] = -1.79413118679668;
  params.B[9] = -0.236760625397454;
  params.B[10] = -1.88049515648573;
  params.B[11] = -0.172667102421156;
  params.u[0] = 0.596576190459043;
  params.u[1] = -0.886050869408099;
  params.u[2] = 0.705019607920525;
  params.alpha[0] = 1.1817256348327;
  params.D[0] = -1.90407247049134;
  params.D[1] = 0.235416351963528;
  params.D[2] = -0.962990212370138;
  params.D[3] = -0.339595211959721;
  params.deltamax[0] = -0.865899672914725;
  params.deltamin[0] = 0.772551673251985;
}
