% qp_long_h = long_h;
% qp_lat_y = lat_y;

figure(1);
subplot(2,1,1);
hold on;
plot(long_h_des.time,long_h_des.signals.values,'b--');
plot(long_h.time,long_h.signals.values,'r');
plot(qp_long_h.time,qp_long_h.signals.values,'g');
title('Longitudal Step Response');
xlabel('Time [s]');ylabel('Z Position [m]');
hold off;
subplot(2,1,2);
hold on;
plot(long_y_des.time,long_y_des.signals.values,'b--');
plot(lat_y.time,lat_y.signals.values,'r');
plot(qp_lat_y.time,qp_lat_y.signals.values,'g');
title('Lateral Step Response');
xlabel('Time [s]');ylabel('Y Position [m]');
legend('Reference','MPCA','QP','Location','SouthEast');
hold off;

% figure(2);
% subplot(3,2,1);
% plot(lat_phi.time,lat_phi.signals.values,'k');
% title('\phi');
% xlabel('Time [s]');ylabel('Angle [rad]');
% subplot(3,2,2);
% plot(long_theta.time,long_theta.signals.values,'k');
% title('\theta');
% xlabel('Time [s]');ylabel('Angle [rad]');
% subplot(3,2,3);
% plot(lat_psi.time,lat_psi.signals.values,'k');
% title('\psi');
% xlabel('Time [s]');ylabel('Angle [rad]');
% subplot(3,2,4);
% plot(long_gamma.time,long_gamma.signals.values,'k');
% title('\gamma');
% xlabel('Time [s]');ylabel('Angle [rad]');
% subplot(3,2,5);
% plot(lat_beta.time,lat_beta.signals.values,'k');
% title('Sideslip \beta');
% xlabel('Time [s]');ylabel('Angle [rad]');
% subplot(3,2,6);
% plot(long_alpha.time,long_alpha.signals.values,'k');
% title('Angle of attack \alpha');
% xlabel('Time [s]');ylabel('Angle [rad]');

mpca_cost = 0;
% qp_cost = 0;
cost = 0;
tau_star = [ 0 0 0 ]';
tau = [ 0 0 0 ]';
for i=1:length(delta.time)-1
    tau_star(:,i) = [ dR.signals.values(i) dP.signals.values(i) dY.signals.values(i) ]';
    tau(:,i) = [C(:,1) C(:,3) C(:,5) C(:,7) ]*delta.signals.values(i,:)';
    cost = cost + (tau_star(1,i)-tau(1,i))^2 + (tau_star(2,i)-tau(2,i))^2 + (tau_star(3,i)-tau(3,i))^2 + 0.01*( (D(1)*delta.signals.values(i,1))^2 + (D(2)*delta.signals.values(i,2))^2 + (D(3)*delta.signals.values(i,3))^2 + (D(4)*delta.signals.values(i,4))^2 );
    mpca_cost(i) = cost;
%     qp_cost(i) = cost;
end

figure(3);
hold on;
plot(delta.time(1:length(mpca_cost)),mpca_cost,'b');
plot(delta.time(1:length(qp_cost)),qp_cost,'r');
legend('MPCA Cost','QP Cost','Location','NorthWest');
title('Cumulative Cost');
xlabel('Time [s]');
ylabel('Cost');
hold off;

figure(4);
hold on;
p1 = plot(delta.time(1:length(tau_star(1,:))),tau_star(1,:),'k');
p2 = plot(delta.time(1:length(tau(1,:))),tau(1,:),'k:','LineWidth',2);
p3 = plot(delta.time(1:length(tau_star(2:3,:))),tau_star(:,:),'k');
p4 = plot(delta.time(1:length(tau(2:3,:))),tau(:,:),'k:','LineWidth',2);
set(p3,'HandleVisibility','off');
set(p4,'HandleVisibility','off');
hold off;
legend('\tau^*','\tau','Location','Best');
title('MPCA Virtual Input Tracking');
xlabel('Time [s]');
ylabel('Virtual Input');
text(2.3,0.2,'\leftarrow \delta_R','HorizontalAlignment','left');
text(2.1,-0.6,'\leftarrow \delta_Y','HorizontalAlignment','left');
text(6.2,-0.2,'\leftarrow \delta_P','HorizontalAlignment','left');

figure(5);
hold on;
p6 = plot([0 10],[ 7*pi/180 7*pi/180],'Color',[0.2 0.2 0.2]); 
p7 = plot([0 10],[ -7*pi/180 -7*pi/180],'Color',[0.2 0.2 0.2]); 
set(p6,'HandleVisibility','off');
set(p7,'HandleVisibility','off');
plot(delta.time,delta.signals.values(:,1),'k');
plot(delta.time,delta.signals.values(:,2),'k--','LineWidth',1);
plot(delta.time,delta.signals.values(:,3),'k:','LineWidth',1);
plot(delta.time,delta.signals.values(:,4),'k-.','LineWidth',1);
hold off;
legend('\delta_1','\delta_2','\delta_3','\delta_4','Location','SouthOutside','Orientation','horizontal');
title('MPCA Actuator Response');
xlabel('Time [s]');
ylabel('Deflection [rad]');

figure(6);
subplot(2,1,1);
plot(lat_ay.time,lat_ay.signals.values);
xlabel('Time [s]');
ylabel('Acceleration [m/s^2]');
title('Missile Lateral Acceleration');
subplot(2,1,2);
plot(long_az.time,long_az.signals.values);
xlabel('Time [s]');
ylabel('Acceleration [m/s^2]');
title('Missile Longitudal Acceleration');