% csolve  Solves a custom quadratic program very rapidly.
%
% [vars, status] = csolve(params, settings)
%
% solves the convex optimization problem
%
%   minimize(square(y_1(1) - u_des_1(1)) + square(y_1(2) - u_des_1(2)) + square(y_1(3) - u_des_1(3)) + square(y_2(1) - u_des_2(1)) + square(y_2(2) - u_des_2(2)) + square(y_2(3) - u_des_2(3)) + square(y_3(1) - u_des_3(1)) + square(y_3(2) - u_des_3(2)) + square(y_3(3) - u_des_3(3)) + square(y_4(1) - u_des_4(1)) + square(y_4(2) - u_des_4(2)) + square(y_4(3) - u_des_4(3)) + square(y_5(1) - u_des_5(1)) + square(y_5(2) - u_des_5(2)) + square(y_5(3) - u_des_5(3)) + alpha*(square(D(1)*delta_cmd_0(1)) + square(D(2)*delta_cmd_0(2)) + square(D(3)*delta_cmd_0(3)) + square(D(4)*delta_cmd_0(4)) + square(D(1)*delta_cmd_1(1)) + square(D(2)*delta_cmd_1(2)) + square(D(3)*delta_cmd_1(3)) + square(D(4)*delta_cmd_1(4)) + square(D(1)*delta_cmd_2(1)) + square(D(2)*delta_cmd_2(2)) + square(D(3)*delta_cmd_2(3)) + square(D(4)*delta_cmd_2(4)) + square(D(1)*delta_cmd_3(1)) + square(D(2)*delta_cmd_3(2)) + square(D(3)*delta_cmd_3(3)) + square(D(4)*delta_cmd_3(4)) + square(D(1)*delta_cmd_4(1)) + square(D(2)*delta_cmd_4(2)) + square(D(3)*delta_cmd_4(3)) + square(D(4)*delta_cmd_4(4))))
%   subject to
%     delta_1 == A*delta_0 + B*delta_cmd_0
%     delta_2 == A*delta_1 + B*delta_cmd_1
%     delta_3 == A*delta_2 + B*delta_cmd_2
%     delta_4 == A*delta_3 + B*delta_cmd_3
%     delta_5 == A*delta_4 + B*delta_cmd_4
%     y_0 == C*delta_0
%     y_1 == C*delta_1
%     y_2 == C*delta_2
%     y_3 == C*delta_3
%     y_4 == C*delta_4
%     y_5 == C*delta_5
%     deltamin <= delta_1
%     deltamin <= delta_2
%     deltamin <= delta_3
%     deltamin <= delta_4
%     deltamin <= delta_5
%     delta_1 <= deltamax
%     delta_2 <= deltamax
%     delta_3 <= deltamax
%     delta_4 <= deltamax
%     delta_5 <= deltamax
%
% with variables
%  delta_1   8 x 1
%  delta_2   8 x 1
%  delta_3   8 x 1
%  delta_4   8 x 1
%  delta_5   8 x 1
% delta_cmd_0   4 x 1
% delta_cmd_1   4 x 1
% delta_cmd_2   4 x 1
% delta_cmd_3   4 x 1
% delta_cmd_4   4 x 1
%      y_0   3 x 1
%      y_1   3 x 1
%      y_2   3 x 1
%      y_3   3 x 1
%      y_4   3 x 1
%      y_5   3 x 1
%
% and parameters
%        A   8 x 8
%        B   8 x 4
%        C   3 x 8
%        D   1 x 4
%    alpha   1 x 1    positive
%  delta_0   8 x 1
% deltamax   1 x 1    positive
% deltamin   1 x 1    negative
%  u_des_1   3 x 1
%  u_des_2   3 x 1
%  u_des_3   3 x 1
%  u_des_4   3 x 1
%  u_des_5   3 x 1
%
% Note:
%   - Check status.converged, which will be 1 if optimization succeeded.
%   - You don't have to specify settings if you don't want to.
%   - To hide output, use settings.verbose = 0.
%   - To change iterations, use settings.max_iters = 20.
%   - You may wish to compare with cvxsolve to check the solver is correct.
%
% Specify params.A, ..., params.u_des_5, then run
%   [vars, status] = csolve(params, settings)


% Produced by CVXGEN, 2011-05-04 05:18:51 -0700.
% CVXGEN is Copyright (C) 2006-2011 Jacob Mattingley, jem@cvxgen.com.
% The code in this file is Copyright (C) 2006-2011 Jacob Mattingley.
% CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial
% applications without prior written permission from Jacob Mattingley.

% Filename: csolve.m.
% Description: Help file for the Matlab solver interface.
