/* Produced by CVXGEN, 2011-05-04 05:18:50 -0700.  */
/* CVXGEN is Copyright (C) 2006-2011 Jacob Mattingley, jem@cvxgen.com. */
/* The code in this file is Copyright (C) 2006-2011 Jacob Mattingley. */
/* CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial */
/* applications without prior written permission from Jacob Mattingley. */

/* Filename: csolve.c. */
/* Description: mex-able file for running cvxgen solver. */

#include "mex.h"
#include "solver.h"

Vars vars;
Params params;
Workspace work;
Settings settings;
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
  int i, j;
  mxArray *xm, *cell, *xm_cell;
  double *src;
  double *dest;
  double *dest_cell;
  int valid_vars;
  int steps;
  int this_var_errors;
  int warned_diags;
  int prepare_for_c = 0;
  int extra_solves;
  const char *status_names[] = {"optval", "gap", "steps", "converged"};
  mwSize dims1x1of1[1] = {1};
  mwSize dims[1];

  const char *var_names[] = {"delta_1", "delta_2", "delta_3", "delta_4", "delta_5", "delta_cmd_0", "delta_cmd_1", "delta_cmd_2", "delta_cmd_3", "delta_cmd_4", "y_0", "y_1", "y_2", "y_3", "y_4", "y_5", "delta", "delta_cmd", "y"};
  const int num_var_names = 19;

  /* Avoid compiler warnings of unused variables by using a dummy assignment. */
  warned_diags = j = 0;
  extra_solves = 0;

  set_defaults();

  /* Check we got the right number of arguments. */
  if (nrhs == 0)
    mexErrMsgTxt("Not enough arguments: You need to specify at least the parameters.\n");

  if (nrhs > 1) {
    /* Assume that the second argument is the settings. */
    if (mxGetField(prhs[1], 0, "eps") != NULL)
      settings.eps = *mxGetPr(mxGetField(prhs[1], 0, "eps"));

    if (mxGetField(prhs[1], 0, "max_iters") != NULL)
      settings.max_iters = *mxGetPr(mxGetField(prhs[1], 0, "max_iters"));

    if (mxGetField(prhs[1], 0, "refine_steps") != NULL)
      settings.refine_steps = *mxGetPr(mxGetField(prhs[1], 0, "refine_steps"));

    if (mxGetField(prhs[1], 0, "verbose") != NULL)
      settings.verbose = *mxGetPr(mxGetField(prhs[1], 0, "verbose"));

    if (mxGetField(prhs[1], 0, "better_start") != NULL)
      settings.better_start = *mxGetPr(mxGetField(prhs[1], 0, "better_start"));

    if (mxGetField(prhs[1], 0, "verbose_refinement") != NULL)
      settings.verbose_refinement = *mxGetPr(mxGetField(prhs[1], 0,
            "verbose_refinement"));

    if (mxGetField(prhs[1], 0, "debug") != NULL)
      settings.debug = *mxGetPr(mxGetField(prhs[1], 0, "debug"));

    if (mxGetField(prhs[1], 0, "kkt_reg") != NULL)
      settings.kkt_reg = *mxGetPr(mxGetField(prhs[1], 0, "kkt_reg"));

    if (mxGetField(prhs[1], 0, "s_init") != NULL)
      settings.s_init = *mxGetPr(mxGetField(prhs[1], 0, "s_init"));

    if (mxGetField(prhs[1], 0, "z_init") != NULL)
      settings.z_init = *mxGetPr(mxGetField(prhs[1], 0, "z_init"));

    if (mxGetField(prhs[1], 0, "resid_tol") != NULL)
      settings.resid_tol = *mxGetPr(mxGetField(prhs[1], 0, "resid_tol"));

    if (mxGetField(prhs[1], 0, "extra_solves") != NULL)
      extra_solves = *mxGetPr(mxGetField(prhs[1], 0, "extra_solves"));
    else
      extra_solves = 0;

    if (mxGetField(prhs[1], 0, "prepare_for_c") != NULL)
      prepare_for_c = *mxGetPr(mxGetField(prhs[1], 0, "prepare_for_c"));
  }

  valid_vars = 0;

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "A");

  if (xm == NULL) {
    printf("could not find params.A.\n");
  } else {
    if (!((mxGetM(xm) == 8) && (mxGetN(xm) == 8))) {
      printf("A must be size (8,8), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter A must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter A must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter A must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.A;
      src = mxGetPr(xm);

      for (i = 0; i < 64; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "B");

  if (xm == NULL) {
    printf("could not find params.B.\n");
  } else {
    if (!((mxGetM(xm) == 8) && (mxGetN(xm) == 4))) {
      printf("B must be size (8,4), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter B must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter B must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter B must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.B;
      src = mxGetPr(xm);

      for (i = 0; i < 32; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "C");

  if (xm == NULL) {
    printf("could not find params.C.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 8))) {
      printf("C must be size (3,8), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter C must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter C must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter C must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.C;
      src = mxGetPr(xm);

      for (i = 0; i < 24; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "D");

  if (xm == NULL) {
    printf("could not find params.D.\n");
  } else {
    if (!((mxGetM(xm) == 1) && (mxGetN(xm) == 4))) {
      printf("D must be size (1,4), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter D must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter D must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter D must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.D;
      src = mxGetPr(xm);

      for (i = 0; i < 4; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "alpha");

  if (xm == NULL) {
    printf("could not find params.alpha.\n");
  } else {
    if (!((mxGetM(xm) == 1) && (mxGetN(xm) == 1))) {
      printf("alpha must be size (1,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter alpha must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter alpha must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter alpha must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.alpha;
      src = mxGetPr(xm);

      for (i = 0; i < 1; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "delta_0");

  if (xm == NULL) {
    printf("could not find params.delta_0.\n");
  } else {
    if (!((mxGetM(xm) == 8) && (mxGetN(xm) == 1))) {
      printf("delta_0 must be size (8,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter delta_0 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter delta_0 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter delta_0 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.delta_0;
      src = mxGetPr(xm);

      for (i = 0; i < 8; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "deltamax");

  if (xm == NULL) {
    printf("could not find params.deltamax.\n");
  } else {
    if (!((mxGetM(xm) == 1) && (mxGetN(xm) == 1))) {
      printf("deltamax must be size (1,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter deltamax must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter deltamax must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter deltamax must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.deltamax;
      src = mxGetPr(xm);

      for (i = 0; i < 1; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "deltamin");

  if (xm == NULL) {
    printf("could not find params.deltamin.\n");
  } else {
    if (!((mxGetM(xm) == 1) && (mxGetN(xm) == 1))) {
      printf("deltamin must be size (1,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter deltamin must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter deltamin must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter deltamin must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.deltamin;
      src = mxGetPr(xm);

      for (i = 0; i < 1; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "u_des_1");

  if (xm == NULL) {
    /* Attempt to pull u_des_1 from a cell array, as an additional option. */
    cell = mxGetField(prhs[0], 0, "u_des");
    if (cell != NULL)
      xm = mxGetCell(cell, 0);
  }

  if (xm == NULL) {
    printf("could not find params.u_des_1 or params.u_des{1}.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 1))) {
      printf("u_des_1 must be size (3,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter u_des_1 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter u_des_1 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter u_des_1 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.u_des_1;
      src = mxGetPr(xm);

      for (i = 0; i < 3; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "u_des_2");

  if (xm == NULL) {
    /* Attempt to pull u_des_2 from a cell array, as an additional option. */
    cell = mxGetField(prhs[0], 0, "u_des");
    if (cell != NULL)
      xm = mxGetCell(cell, 1);
  }

  if (xm == NULL) {
    printf("could not find params.u_des_2 or params.u_des{2}.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 1))) {
      printf("u_des_2 must be size (3,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter u_des_2 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter u_des_2 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter u_des_2 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.u_des_2;
      src = mxGetPr(xm);

      for (i = 0; i < 3; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "u_des_3");

  if (xm == NULL) {
    /* Attempt to pull u_des_3 from a cell array, as an additional option. */
    cell = mxGetField(prhs[0], 0, "u_des");
    if (cell != NULL)
      xm = mxGetCell(cell, 2);
  }

  if (xm == NULL) {
    printf("could not find params.u_des_3 or params.u_des{3}.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 1))) {
      printf("u_des_3 must be size (3,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter u_des_3 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter u_des_3 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter u_des_3 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.u_des_3;
      src = mxGetPr(xm);

      for (i = 0; i < 3; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "u_des_4");

  if (xm == NULL) {
    /* Attempt to pull u_des_4 from a cell array, as an additional option. */
    cell = mxGetField(prhs[0], 0, "u_des");
    if (cell != NULL)
      xm = mxGetCell(cell, 3);
  }

  if (xm == NULL) {
    printf("could not find params.u_des_4 or params.u_des{4}.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 1))) {
      printf("u_des_4 must be size (3,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter u_des_4 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter u_des_4 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter u_des_4 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.u_des_4;
      src = mxGetPr(xm);

      for (i = 0; i < 3; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  this_var_errors = 0;

  xm = mxGetField(prhs[0], 0, "u_des_5");

  if (xm == NULL) {
    /* Attempt to pull u_des_5 from a cell array, as an additional option. */
    cell = mxGetField(prhs[0], 0, "u_des");
    if (cell != NULL)
      xm = mxGetCell(cell, 4);
  }

  if (xm == NULL) {
    printf("could not find params.u_des_5 or params.u_des{5}.\n");
  } else {
    if (!((mxGetM(xm) == 3) && (mxGetN(xm) == 1))) {
      printf("u_des_5 must be size (3,1), not (%d,%d).\n", mxGetM(xm), mxGetN(xm));
      this_var_errors++;
    }

    if (mxIsComplex(xm)) {
      printf("parameter u_des_5 must be real.\n");
      this_var_errors++;
    }

    if (!mxIsClass(xm, "double")) {
      printf("parameter u_des_5 must be a full matrix of doubles.\n");
      this_var_errors++;
    }

    if (mxIsSparse(xm)) {
      printf("parameter u_des_5 must be a full matrix.\n");
      this_var_errors++;
    }

    if (this_var_errors == 0) {
      dest = params.u_des_5;
      src = mxGetPr(xm);

      for (i = 0; i < 3; i++)
        *dest++ = *src++;

      valid_vars++;
    }
  }

  if (valid_vars != 13) {
    printf("Error: %d parameters are invalid.\n", 13 - valid_vars);
    mexErrMsgTxt("invalid parameters found.");
  }

  if (prepare_for_c) {
    printf("settings.prepare_for_c == 1. thus, outputting for C.\n");
    for (i = 0; i < 3; i++)
      printf("  params.u_des_1[%d] = %.6g;\n", i, params.u_des_1[i]);
    for (i = 0; i < 3; i++)
      printf("  params.u_des_2[%d] = %.6g;\n", i, params.u_des_2[i]);
    for (i = 0; i < 3; i++)
      printf("  params.u_des_3[%d] = %.6g;\n", i, params.u_des_3[i]);
    for (i = 0; i < 3; i++)
      printf("  params.u_des_4[%d] = %.6g;\n", i, params.u_des_4[i]);
    for (i = 0; i < 3; i++)
      printf("  params.u_des_5[%d] = %.6g;\n", i, params.u_des_5[i]);
    for (i = 0; i < 1; i++)
      printf("  params.alpha[%d] = %.6g;\n", i, params.alpha[i]);
    for (i = 0; i < 4; i++)
      printf("  params.D[%d] = %.6g;\n", i, params.D[i]);
    for (i = 0; i < 64; i++)
      printf("  params.A[%d] = %.6g;\n", i, params.A[i]);
    for (i = 0; i < 8; i++)
      printf("  params.delta_0[%d] = %.6g;\n", i, params.delta_0[i]);
    for (i = 0; i < 32; i++)
      printf("  params.B[%d] = %.6g;\n", i, params.B[i]);
    for (i = 0; i < 24; i++)
      printf("  params.C[%d] = %.6g;\n", i, params.C[i]);
    for (i = 0; i < 1; i++)
      printf("  params.deltamin[%d] = %.6g;\n", i, params.deltamin[i]);
    for (i = 0; i < 1; i++)
      printf("  params.deltamax[%d] = %.6g;\n", i, params.deltamax[i]);
  }

  /* Perform the actual solve in here. */
  steps = solve();

  /* For profiling purposes, allow extra silent solves if desired. */
  settings.verbose = 0;
  for (i = 0; i < extra_solves; i++)
    solve();

  /* Update the status variables. */
  plhs[1] = mxCreateStructArray(1, dims1x1of1, 4, status_names);

  xm = mxCreateDoubleMatrix(1, 1, mxREAL);
  mxSetField(plhs[1], 0, "optval", xm);
  *mxGetPr(xm) = work.optval;

  xm = mxCreateDoubleMatrix(1, 1, mxREAL);
  mxSetField(plhs[1], 0, "gap", xm);
  *mxGetPr(xm) = work.gap;

  xm = mxCreateDoubleMatrix(1, 1, mxREAL);
  mxSetField(plhs[1], 0, "steps", xm);
  *mxGetPr(xm) = steps;

  xm = mxCreateDoubleMatrix(1, 1, mxREAL);
  mxSetField(plhs[1], 0, "converged", xm);
  *mxGetPr(xm) = work.converged;

  /* Extract variable values. */
  plhs[0] = mxCreateStructArray(1, dims1x1of1, num_var_names, var_names);

  /* Create cell arrays for indexed variables. */
  dims[0] = 5;
  cell = mxCreateCellArray(1, dims);
  mxSetField(plhs[0], 0, "delta", cell);
  dims[0] = 4;
  cell = mxCreateCellArray(1, dims);
  mxSetField(plhs[0], 0, "delta_cmd", cell);
  dims[0] = 5;
  cell = mxCreateCellArray(1, dims);
  mxSetField(plhs[0], 0, "y", cell);

  xm = mxCreateDoubleMatrix(8, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_1", xm);
  xm_cell = mxCreateDoubleMatrix(8, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta");
  mxSetCell(cell, 0, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_1;
  for (i = 0; i < 8; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(8, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_2", xm);
  xm_cell = mxCreateDoubleMatrix(8, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta");
  mxSetCell(cell, 1, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_2;
  for (i = 0; i < 8; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(8, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_3", xm);
  xm_cell = mxCreateDoubleMatrix(8, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta");
  mxSetCell(cell, 2, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_3;
  for (i = 0; i < 8; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(8, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_4", xm);
  xm_cell = mxCreateDoubleMatrix(8, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta");
  mxSetCell(cell, 3, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_4;
  for (i = 0; i < 8; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(8, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_5", xm);
  xm_cell = mxCreateDoubleMatrix(8, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta");
  mxSetCell(cell, 4, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_5;
  for (i = 0; i < 8; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(4, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_cmd_0", xm);
  dest = mxGetPr(xm);
  src = vars.delta_cmd_0;
  for (i = 0; i < 4; i++) {
    *dest++ = *src++;
  }
  xm = mxCreateDoubleMatrix(4, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_cmd_1", xm);
  xm_cell = mxCreateDoubleMatrix(4, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta_cmd");
  mxSetCell(cell, 0, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_cmd_1;
  for (i = 0; i < 4; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(4, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_cmd_2", xm);
  xm_cell = mxCreateDoubleMatrix(4, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta_cmd");
  mxSetCell(cell, 1, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_cmd_2;
  for (i = 0; i < 4; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(4, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_cmd_3", xm);
  xm_cell = mxCreateDoubleMatrix(4, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta_cmd");
  mxSetCell(cell, 2, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_cmd_3;
  for (i = 0; i < 4; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(4, 1, mxREAL);
  mxSetField(plhs[0], 0, "delta_cmd_4", xm);
  xm_cell = mxCreateDoubleMatrix(4, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "delta_cmd");
  mxSetCell(cell, 3, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.delta_cmd_4;
  for (i = 0; i < 4; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_0", xm);
  dest = mxGetPr(xm);
  src = vars.y_0;
  for (i = 0; i < 3; i++) {
    *dest++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_1", xm);
  xm_cell = mxCreateDoubleMatrix(3, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "y");
  mxSetCell(cell, 0, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.y_1;
  for (i = 0; i < 3; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_2", xm);
  xm_cell = mxCreateDoubleMatrix(3, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "y");
  mxSetCell(cell, 1, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.y_2;
  for (i = 0; i < 3; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_3", xm);
  xm_cell = mxCreateDoubleMatrix(3, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "y");
  mxSetCell(cell, 2, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.y_3;
  for (i = 0; i < 3; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_4", xm);
  xm_cell = mxCreateDoubleMatrix(3, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "y");
  mxSetCell(cell, 3, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.y_4;
  for (i = 0; i < 3; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
  xm = mxCreateDoubleMatrix(3, 1, mxREAL);
  mxSetField(plhs[0], 0, "y_5", xm);
  xm_cell = mxCreateDoubleMatrix(3, 1, mxREAL);
  cell = mxGetField(plhs[0], 0, "y");
  mxSetCell(cell, 4, xm_cell);

  dest = mxGetPr(xm);
  dest_cell = mxGetPr(xm_cell);
  src = vars.y_5;
  for (i = 0; i < 3; i++) {
    *dest++ = *src;
    *dest_cell++ = *src++;
  }
}
