/* Produced by CVXGEN, 2011-05-06 06:09:04 -0700.  */
/* CVXGEN is Copyright (C) 2006-2011 Jacob Mattingley, jem@cvxgen.com. */
/* The code in this file is Copyright (C) 2006-2011 Jacob Mattingley. */
/* CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial */
/* applications without prior written permission from Jacob Mattingley. */

/* Filename: testsolver.c. */
/* Description: Basic test harness for solver.c. */

#include "solver.h"

Vars vars;
Params params;
Workspace work;
Settings settings;
#define NUMTESTS 0

int main(int argc, char **argv) {
  int num_iters;
#if (NUMTESTS > 0)
  int i;
  double time;
  double time_per;
#endif

  set_defaults();
  setup_indexing();
  load_default_data();

  /* Solve problem instance for the record. */
  settings.verbose = 1;
  num_iters = solve();

#ifndef ZERO_LIBRARY_MODE
#if (NUMTESTS > 0)
  /* Now solve multiple problem instances for timing purposes. */
  settings.verbose = 0;

  tic();
  for (i = 0; i < NUMTESTS; i++) {
    solve();
  }
  time = tocq();

  printf("Timed %d solves over %.3f seconds.\n", NUMTESTS, time);
  time_per = time / NUMTESTS;

  if (time_per > 1) {
    printf("Actual time taken per solve: %.3g s.\n", time_per);
  } else if (time_per > 1e-3) {
    printf("Actual time taken per solve: %.3g ms.\n", 1e3*time_per);
  } else {
    printf("Actual time taken per solve: %.3g us.\n", 1e6*time_per);
  }
#endif
#endif

  return 0;
}

void load_default_data(void) {
  params.B[0] = 0.203191610298302;
  params.B[1] = 0.832591290472419;
  params.B[2] = -0.836381044348223;
  params.B[3] = 0.0433104207906521;
  params.B[4] = 1.57178781739062;
  params.B[5] = 1.58517235573375;
  params.B[6] = -1.49765875814465;
  params.B[7] = -1.17102848744725;
  params.B[8] = -1.79413118679668;
  params.B[9] = -0.236760625397454;
  params.B[10] = -1.88049515648573;
  params.B[11] = -0.172667102421156;
  params.B[12] = 0.596576190459043;
  params.B[13] = -0.886050869408099;
  params.B[14] = 0.705019607920525;
  params.B[15] = 0.363451269665403;
  params.B[16] = -1.90407247049134;
  params.B[17] = 0.235416351963528;
  params.u[0] = -0.962990212370138;
  params.u[1] = -0.339595211959721;
  params.u[2] = -0.865899672914725;
  params.alpha[0] = 1.38627583662599;
  params.D[0] = -0.238185129317042;
  params.D[1] = -1.37252904610015;
  params.D[2] = 0.178596072127379;
  params.D[3] = 1.12125905804547;
  params.D[4] = -0.774545870495281;
  params.D[5] = -1.11216846427127;
  params.deltamin[0] = -0.775942515111298;
  params.deltamin[1] = -1.87276729972086;
  params.deltamin[2] = -1.95199084494587;
  params.deltamin[3] = -1.34476735182563;
  params.deltamin[4] = -1.8056682170768;
  params.deltamin[5] = -1.69150174258636;
  params.deltamax[0] = 0.755988082657778;
  params.deltamax[1] = 0.184434017743448;
  params.deltamax[2] = 1.30682180504707;
  params.deltamax[3] = 1.1156815247769;
  params.deltamax[4] = 0.723129526125156;
  params.deltamax[5] = 0.450109009679664;
}
